<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypeRECA_3 extends Record {
    public $name = "riskscoring_value_calc";
    
    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cod_cons",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "subtipo",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "dtref",
            'position' => 11,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "perfx1",
            'position' => 19,
            'size' => 5,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "valfx1",
            'position' => 24,
            'size' => 17,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "perfx2",
            'position' => 41,
            'size' => 5,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "valfx2",
            'position' => 46,
            'size' => 17,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "perfx3",
            'position' => 63,
            'size' => 5,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "valfx3",
            'position' => 68,
            'size' => 17,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "perfx4",
            'position' => 85,
            'size' => 5,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "valfx4",
            'position' => 90,
            'size' => 17,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 107,
            'size' => 9,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['cod_feat'] = substr($values, 4, 4);
        $newValues['subtipo'] = substr($values, 8, 2);
        $newValues['bairro'] = substr($values, 10, 45);
        $newValues['cidade'] = substr($values, 55, 45);
        $newValues['uf'] = substr($values, 100, 2);
        $newValues['cep'] = substr($values, 102, 8);
        $newValues['ident'] = substr($values, 110, 1);
        $newValues['filler'] = substr($values, 111, 4);
        
        $this->setColumnsValues($newValues);
    }
}